
import json
import sys,os
import logging,argparse
import util

logger = logging.getLogger(__name__)

def args_parsing(args):

    argparser = argparse.ArgumentParser(prog=os.path.basename(args[0]))


    argparser.add_argument('treeStatisticsJsonFile', help='statistics about tree in json file')
    parse_result=argparser.parse_args(args[1:])



    # handle input/output file argument
    jsonfile=os.path.abspath(parse_result.treeStatisticsJsonFile).replace('\\','/')
    util.check_isreadablefile(jsonfile)

    return  (jsonfile)

def readJsonFile(jsonfile):
    if os.path.isfile(jsonfile):
        try:
           result=json.load( file( jsonfile ) )
        except Exception as e:
           logger.warning("corrupted json file '" + jsonfile + "' :" + str(e))
           result=None
    else:
        logger.warning("cannot find json file '" + jsonfile + "'")
        result=None
    return result



def getList(jsonfile):
    mapper=readJsonFile(jsonfile)
    lst=mapper['depth_index']
    return lst

def printList(lst):
    import pprint
    print("Listing of number of nodes at each depth:")
    pprint.pprint(lst)
    print("Note: the 0 based index of the list is the depth")
    print("Total number of nodes : " + str(sum(lst)) );
    sys.stderr.flush();
    sys.stdout.flush(); # needed if called as subprocess by other process
                        # which wants to display output before the plot is shown



def showPlot(lst):
    import matplotlib.pyplot as plt
    plt.plot(lst, 'ro')
    plt.ylabel('number nodes')
    plt.xlabel('tree depth')
    plt.show()


def main(args):
    """
	 plot tree statistics 

	 usage:  plot   treestatistics.json


    """
    (jsonfile)=args_parsing(args)
    lst=getList(jsonfile) 
    printList(lst)
    showPlot(lst)
    #p = Process(target=showPlot, args=lst)
    #p.daemon=True
    #p.start()
    #p.join(2000)
    #import time
    #time.sleep(2)

if __name__ == "__main__":
    try:
        main(sys.argv)
    except KeyboardInterrupt as e:
        # Note: KeyboardInterrupt happens when user kills program with CTRL-C
        #       When this happens we display a nice message instead of a traceback  :
        print >> sys.stderr, "\n\nExiting on user cancel."
        sys.exit(1)

             
